Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util
Class PriorityQueue

    java.lang.Object
      java.util.AbstractCollection
          edu.emory.mathcs.backport.java.util.AbstractCollection
              edu.emory.mathcs.backport.java.util.AbstractQueue
                  edu.emory.mathcs.backport.java.util.PriorityQueue

All Implemented Interfaces:
  java.util.Collection, Queue, java.io.Serializable

public class PriorityQueue
extends AbstractQueue
implements java.io.Serializable, Queue

An unbounded queue that supports element retrieval in the order of relative priority. The ordering can be defined via an explicit comparator; otherwise, the natural ordering of elements is used. Element at the head of the queue is always the smallest one according to the given ordering.

While this queue is logically unbounded, attempted additions may fail due to resource exhaustion (causing `OutOfMemoryError`). This class does not permit `null` elements. A priority queue relying on natural ordering also does not permit insertion of non-comparable objects (doing so results in `ClassCastException`).

This class and its iterator implement all of the optional methods of the `Collection` and `Iterator` interfaces. The Iterator provided in method `iterator()` is not guaranteed to traverse the elements of the PriorityQueue in any particular order. If you need ordered traversal, consider using `Arrays.sort(pq.toArray())`.

Operations on this class make no guarantees about the ordering of elements with equal priority. If you need to enforce an ordering, you can define custom classes or comparators that use a secondary key to break ties in primary priority values. See `PriorityBlockingQueue` for an example.

Implementation note: basic mutative methods (insert, offer, remove, poll etc) have complexity O(log(n)). Parameterless inspection methods (peek, element,isEmpty) have complexity O(1). Methods contains(Object) and remove(Object) have complexity O(n).

Since:
  1.5
Author:
  Dawid Kurzyniec
See Also:
  Serialized Form

Constructor Summary
`PriorityQueue()` Creates a `PriorityQueue` with the default initial capacity (11) that orders its elements according to their natural ordering.
`PriorityQueue(java.util.Collection c)` Creates a `PriorityQueue` containing the elements in the specified collection.
`PriorityQueue(java.util.Comparator comparator)` Creates a `PriorityQueue` with the specified initial capacity that orders its elements according to the specified comparator.
`PriorityQueue(int initialCapacity)` Creates a `PriorityQueue` with the specified initial capacity that orders its elements according to their natural ordering.
`PriorityQueue(int initialCapacity, java.util.Comparator comparator)`
`PriorityQueue(PriorityQueue q)` Creates a `PriorityQueue` containing the elements from the specified priority queue.
`PriorityQueue(java.util.SortedSet s)` Creates a `PriorityQueue` containing the elements from the specified sorted set.

Method Summary
`boolean` | `add(java.lang.Object o)` Inserts the specified element into this priority queue.
`void` | `clear()` Removes all of the elements from this queue.
`java.util.Comparator` | `comparator()` Returns the comparator used to order the elements in this queue, or `null` if this queue uses the natural ordering of its elements.
`boolean` | `contains(java.lang.Object o)` Returns `true` if this queue contains the specified element.
`java.lang.Object` | `element()` Retrieves, but does not remove, the head of this queue.
`boolean` | `isEmpty()` Returns `true` if this queue contains no elements.
`java.util.Iterator` | `iterator()` Returns an iterator over the elements in this queue.
`boolean` | `offer(java.lang.Object o)` Inserts the specified element into this priority queue.
`java.lang.Object` | `peek()` Retrieves, but does not remove, the head of this queue, or returns `null` if this queue is empty.
`java.lang.Object` | `poll()` Retrieves and removes the head of this queue, or returns `null` if this queue is empty.
`java.lang.Object` | `remove()` Retrieves and removes the head of this queue.
`boolean` | `remove(java.lang.Object o)` Removes a single instance of the specified element from this queue, if it is present.
`int` | `size()` Returns the number of elements in this priority queue.
`java.lang.Object[]` | `toArray()` Returns an array containing all of the elements in this queue.
`java.lang.Object[]` | `toArray(java.lang.Object[] a)` Returns an array containing all of the elements in this queue; the runtime type of the returned array is that of the specified array.

Methods inherited from class edu.emory.mathcs.backport.java.util.AbstractQueue
`addAll`

Methods inherited from class java.util.AbstractCollection
`containsAll, removeAll, retainAll, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Collection
`addAll, containsAll, equals, hashCode, removeAll, retainAll`

Constructor Detail

### PriorityQueue

    public PriorityQueue()

  Creates a `PriorityQueue` with the default initial capacity (11) that orders its elements according to their natural ordering.

### PriorityQueue

    public PriorityQueue(int initialCapacity)

  Creates a `PriorityQueue` with the specified initial capacity that orders its elements according to their natural ordering.

Parameters:
  `initialCapacity` - the initial capacity for this priority queue
Throws:
  `java.lang.IllegalArgumentException` - if `initialCapacity` is less than 1

### PriorityQueue

    public PriorityQueue(java.util.Comparator comparator)

  Creates a `PriorityQueue` with the specified initial capacity that orders its elements according to the specified comparator.

Parameters:
  `comparator` - the comparator used to order this priority queue. If `null` then the order depends on the elements' natural ordering.
Throws:
  `java.lang.IllegalArgumentException` - if `initialCapacity` is less than 1

### PriorityQueue

    public PriorityQueue(int initialCapacity,
                         java.util.Comparator comparator)

### PriorityQueue

    public PriorityQueue(PriorityQueue q)

  Creates a `PriorityQueue` containing the elements from the specified priority queue. This priority queue has an initial capacity of 110% of the size of the specified queue, and it is sorted according to the same comparator as the specified queue, or according to the natural ordering of its elements if the specified queue is sorted according to the natural ordering of its elements.

Parameters:
  `q` - the queue whose elements are to be placed into this priority queue.
Throws:
  `java.lang.NullPointerException` - if the specified queue is null

### PriorityQueue

    public PriorityQueue(java.util.SortedSet s)

  Creates a `PriorityQueue` containing the elements from the specified sorted set. This priority queue has an initial capacity of 110% of the size of the specified set, and it is sorted according to the same comparator as the specified set, or according to the natural ordering of its elements if the specified set is sorted according to the natural ordering of its elements.

Parameters:
  `s` - the set whose elements are to be placed into this priority queue.
Throws:
  `java.lang.NullPointerException` - if the specified set or any of its elements are null

### PriorityQueue

    public PriorityQueue(java.util.Collection c)

  Creates a `PriorityQueue` containing the elements in the specified collection. The priority queue has an initial capacity of 110% of the size of the specified collection. If the specified collection is a `SortedSet` or a `PriorityQueue`, this priority queue will be sorted according to the same comparator, or according to the natural ordering of its elements if the collection is sorted according to the natural ordering of its elements. Otherwise, this priority queue is ordered according to the natural ordering of its elements.

Parameters:
  `c` - the collection whose elements are to be placed into this priority queue.
Throws:
  `java.lang.ClassCastException` - if elements of the specified collection cannot be compared to one another according to the priority queue's ordering.
  `java.lang.NullPointerException` - if the specified collection or any of its elements are null

Method Detail

### iterator

    public java.util.Iterator iterator()

  Returns an iterator over the elements in this queue. The iterator does not return the elements in any particular order. The returned iterator is a thread-safe "fast-fail" iterator that will throw `ConcurrentModificationException` upon detected interference.

  Specified by:
    `iterator` in interface `java.util.Collection`
  Returns:
    an iterator over the elements in this queue

### comparator

    public java.util.Comparator comparator()

  Returns the comparator used to order the elements in this queue, or `null` if this queue uses the natural ordering of its elements.

  Returns:
    the comparator used to order the elements in this queue, or `null` if this queue uses the natural ordering of its elements.

### offer

    public boolean offer(java.lang.Object o)

  Inserts the specified element into this priority queue.

  Specified by:
    `offer` in interface `Queue`
  Parameters:
    `o` - the element to add
  Returns:
    `true` (as per the spec for `Queue.offer(java.lang.Object)`)
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with elements currently in the priority queue according to the priority queue's ordering
    `java.lang.NullPointerException` - if the specified element is null

### peek

    public java.lang.Object peek()

  Retrieves, but does not remove, the head of this queue, or returns `null` if this queue is empty.

  Specified by:
    `peek` in interface `Queue`
  Returns:
    the head of this queue, or `null` if this queue is empty

### poll

    public java.lang.Object poll()

  Retrieves and removes the head of this queue, or returns `null` if this queue is empty.

  Specified by:
    `poll` in interface `Queue`
  Returns:
    the head of this queue, or `null` if this queue is empty

### size

    public int size()

  Returns the number of elements in this priority queue.

  Specified by:
    `size` in interface `java.util.Collection`
  Returns:
    the number of elements in this priority queue

### add

    public boolean add(java.lang.Object o)

  Inserts the specified element into this priority queue.

  Specified by:
    `add` in interface `Queue`
  Overrides:
    `add` in class `AbstractQueue`
  Parameters:
    `o` - the element to add
  Returns:
    `true` (as per the spec for `Collection.add(java.lang.Object)`)
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with elements currently in the priority queue according to the priority queue's ordering
    `java.lang.NullPointerException` - if the specified element is null

### remove

    public java.lang.Object remove()

  Retrieves and removes the head of this queue.

  Specified by:
    `remove` in interface `Queue`
  Overrides:
    `remove` in class `AbstractQueue`
  Returns:
    the head of this queue

### element

    public java.lang.Object element()

  Retrieves, but does not remove, the head of this queue.

  Specified by:
    `element` in interface `Queue`
  Overrides:
    `element` in class `AbstractQueue`
  Returns:
    the head of this queue
  Throws:
    `java.util.NoSuchElementException` - of the queue is empty

### isEmpty

    public boolean isEmpty()

  Returns `true` if this queue contains no elements.

  Specified by:
    `isEmpty` in interface `java.util.Collection`
  Returns:
    `true` if this queue contains no elements

### contains

    public boolean contains(java.lang.Object o)

  Returns `true` if this queue contains the specified element. More formally, returns `true` if and only if this queue contains at least one element `e` such that `o.equals(e)`.

  Specified by:
    `contains` in interface `java.util.Collection`
  Parameters:
    `o` - object to be checked for containment in this queue
  Returns:
    `true` if this queue contains the specified element

### toArray

    public java.lang.Object[] toArray()

  Returns an array containing all of the elements in this queue. The returned array elements are in no particular order.

  The returned array will be "safe" in that no references to it are maintained by this queue. (In other words, this method must allocate a new array). The caller is thus free to modify the returned array.

  This method acts as bridge between array-based and collection-based APIs.

  Specified by:
    `toArray` in interface `java.util.Collection`
  Overrides:
    `toArray` in class `AbstractCollection`
  Returns:
    an array containing all of the elements in this queue

### toArray

    public java.lang.Object[] toArray(java.lang.Object[] a)

  Returns an array containing all of the elements in this queue; the runtime type of the returned array is that of the specified array. The returned array elements are in no particular order. If the queue fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this queue.

  If this queue fits in the specified array with room to spare (i.e., the array has more elements than this queue), the element in the array immediately following the end of the queue is set to `null`.

  Like the `toArray()` method, this method acts as bridge between array-based and collection-based APIs. Further, this method allows precise control over the runtime type of the output array, and may, under certain circumstances, be used to save allocation costs.

  Suppose `x` is a queue known to contain only strings. The following code can be used to dump the queue into a newly allocated array of `String`:

           String[] y = x.toArray(new String[0]);

  Note that `toArray(new Object[0])` is identical in function to `toArray()`.

  Specified by:
    `toArray` in interface `java.util.Collection`
  Overrides:
    `toArray` in class `AbstractCollection`
  Parameters:
    `a` - the array into which the elements of the queue are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose
  Returns:
    an array containing all of the elements in this queue
  Throws:
    `java.lang.ArrayStoreException` - if the runtime type of the specified array is not a supertype of the runtime type of every element in this queue
    `java.lang.NullPointerException` - if the specified array is null

### remove

    public boolean remove(java.lang.Object o)

  Removes a single instance of the specified element from this queue, if it is present. Returns `true` if this queue contained the specified element (or equivalently, if this queue changed as a result of the call).

  Specified by:
    `remove` in interface `java.util.Collection`
  Parameters:
    `o` - element to be removed from this queue, if present
  Returns:
    `true` if this queue changed as a result of the call

### clear

    public void clear()

  Removes all of the elements from this queue. The queue will be empty after this call returns.

  Specified by:
    `clear` in interface `java.util.Collection`
  Overrides:
    `clear` in class `AbstractQueue`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD